// Copyright 2003 Regents of the University of California

// Astropulse is free software; you can redistribute it and/or modify it under
// the terms of the GNU General Public License as published by the Free
// Software Foundation; either version 2, or (at your option) any later
// version.

// Astropulse is distributed in the hope that it will be useful, but WITHOUT
// ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
// FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for
// more details.

// You should have received a copy of the GNU General Public License along
// with Astropulse; see the file COPYING.  If not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

#ifndef _WIN32
#include "config.h"
#endif

#include "sbtf.h"

int splitter_bits_to_float(unsigned char *raw, float *data, int nsamples) {
  /* nsamples is number of COMPLEX samples to convert! */
  unsigned int i, j;
  unsigned char s;
  static int first_time=1;
  static float lut[256][8];

  if( nsamples%4 )
    return(-1);

  if (first_time) {
    for (i=0;i<256;i++) {
      s=(unsigned char)i;
      for (j=0;j<4;j++) {
        lut[i][j*2]=2*(s & 1)-1;
        s >>= 1;
        lut[i][j*2+1]=2*(s & 1)-1;
        s >>= 1;
      }
    }
    first_time--;
  }

  for (i=0;i<((unsigned int)nsamples/4);i++) {
    memcpy(data+8*i,lut[raw[i]],8*sizeof(float));
  }

  return(0);
}

